<script type="text/html" data-template-name="gatekeeper">
  <div class="form-row">
    <label for="node-input-broker"><i class="fa fa-globe"></i> <span data-i18n="mqtt.label.broker"></span></label>
    <input type="text" id="node-input-broker">
  </div>
  <div class="form-row">
    <label for="node-input-remoteIP"><i class="fa fa-globe"></i> <span data-i18n="gatekeeper.remote-ip"></span></label>
    <input type="text" id="node-input-remoteIP" placeholder="workstation-ip, e.g. 172.20.33.33">
  </div>
  <div class="form-row">
    <label for="node-input-sideID"><i class="fa fa-exchange"></i> <span data-i18n="gatekeeper.side-id"></span></label>
    <input type="text" id="node-input-sideID">
  </div>
  <div class="form-row">
    <label for="node-input-deviceID"><i class="fa fa-mobile"></i> <span data-i18n="gatekeeper.device-id"></span></label>
    <input type="text" id="node-input-deviceID">
  </div>
  <div class="form-row">
    <label for="node-input-name"><i class="fa fa-tag"></i> <span data-i18n="common.label.name"></span></label>
    <input type="text" id="node-input-name" data-i18n="[placeholder]common.label.name">
  </div>

</script>

<script type="text/javascript">
  RED.nodes.registerType('gatekeeper', {
    category: 'nilvana',
    defaults: {
      name: {
        value: ""
      },
      topic: {
        value: "face/image",
        required: true,
        validate: RED.validators.regex(/^(#$|(\+|[^+#]*)(\/(\+|[^+#]*))*(\/(\+|#|[^+#]*))?$)/)
      },
      qos: {
        value: "1"
      },
      datatype: {
        value: "auto",
        required: true
      },
      broker: {
        // node-red core
        type: "mqtt-broker",
        required: true
      },
      remoteIP: {
        value: '',
        required: true,
        validate: RED.validators.regex(/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/i)
      },
      sideID: {
        value: '',
        required: true,
        validate: RED.validators.regex(/^[a-zA-Z0-9]{6}$/i)
      },
      deviceID: {
        value: '',
        required: false,
      }
    },
    color: "#97BEEB",
    inputs: 0,
    outputs: 1,
    icon: "icons/icon-gatekeeper.png",
    label: function() {
      return this.name || "gatekeeper"
    },
    labelStyle: function() {
      return this.name ? "node_label_italic" : "";
    },
    oneditprepare: function() {
      if (this.qos === undefined) {
        $("#node-input-qos").val("1");
      }
      if (this.datatype === undefined) {
        $("#node-input-datatype").val("auto");
      }
    }
  });

</script>
